#include <iostream>
using namespace std;

int main(){
    long long int n, q;
    long long int d, k[1000], p, keks[1000];
    cin>>n;  // br puta koliko je pronasao plazmu 
    cin>>q; // broj pitanja
    long long int niz[100];
   
    for (long long int i=0; i<n; i++){
        cin>>d;
        cin>>p;
        niz[d-1]=p;
    }
    
    for (long long int i=0; i<q; i++){
        cin>>k[i];
    }
    
   /*for (long long int j=0; j<q; j++){
      for (long long int i=0; i<k[j]; i++){
            cout<<niz[i]<<" ";
    } 
    cout<<endl;*/
   
   long long int pamt, s, m=0, a;
   for (long long int i=0; i<q; i++){
       s=0;
       for (long long int j=0; j<k[i]; j++){
           pamt=0;
           m=j;
           if (niz[j]!=0){
               pamt=niz[j];
               a=j;
               while (pamt>0 && m<k[i]){
                keks[a]=1;
                a++;
               pamt--;
               m++;
               }
            }
       }
       //cout<<s<<endl;
    }
    
    for (long long int i=0; i<q; i++){
        s=0;
       for (long long int j=0; j<k[i]; j++){
          if (keks[j]!=0)
          s+=1;
          else if(keks[j]==1)
          s+=1;
       }cout<<s<<endl;
    }
    
    
    



    
}